<?php
     class ProtectRemoteLogModel {
        public $CorrelationId = '';
        public $Message = '';
        public $LogTime = '';
        public $Level = 1;

    }

    class ProtectRemoteLog {

        public static $logs = [];

        static function pr_log_error($message, $force = false) {

            $settingOptions = new ProtectRemoteSettingOptions();

            if ($settingOptions->getWpLogMode() == false) {
                return;
            }

            $model = new ProtectRemoteLogModel();
            $model->CorrelationId = ProtectRemoteCron::get_correlation_id();
            $model->Message = $message;
            $model->LogTime = (new DateTime('now', new DateTimeZone('UTC')))->format('Y-m-d H:i:s');
            $model->Level = 1;

            self::$logs[] = $model;
            self::pr_log_push($force);
        }

        static function pr_log_info($message, $force = false) {
            
            $settingOptions = new ProtectRemoteSettingOptions();

            if ($settingOptions->getWpLogMode() == false) {
                return;
            }

            $model = new ProtectRemoteLogModel();
            $model->CorrelationId = ProtectRemoteCron::get_correlation_id();
            $model->Message = $message;
            $model->LogTime = (new DateTime('now', new DateTimeZone('UTC')))->format('Y-m-d H:i:s');
            $model->Level = 2;

            self::$logs[] = $model;
            self::pr_log_push($force);
        }

        static function pr_log_warning($message, $force = false) {
            
            $settingOptions = new ProtectRemoteSettingOptions();

            if ($settingOptions->getWpLogMode() == false) {
                return;
            }

            $model = new ProtectRemoteLogModel();
            $model->CorrelationId = ProtectRemoteCron::get_correlation_id();
            $model->Message = $message;
            $model->LogTime = (new DateTime('now', new DateTimeZone('UTC')))->format('Y-m-d H:i:s');
            $model->Level = 3;

            self::$logs[] = $model;
            self::pr_log_push($force);
        }

        static function pr_log_push($force = false) {

            if (empty(self::$logs) || !is_array(self::$logs)) {
                error_log("Invalid or empty events array.");
                return;
            }

            if (count(self::$logs) >= ProtectRemoteVariables::BULK_LOG_COUNT || $force == true) {
                ProtectRemote::send_log_to_pr(self::$logs);
                self::$logs = [];
            }
        }
    }
?>