<?php
    class ProtectRemoteVariables {
        const CRON_TIME_SECOND = 5;
        const MAX_TRY_COUNT = 5;
        const BULK_LOG_COUNT = 5;
        const APP_VERSION = "0.0.9";
        const PLUGIN_KEY = "pr-plugin-settings";
        const PR_WP_PAGE = "https://www.protectremote.com/wordpress";    

        public function __construct() {

        }

        public static function isProd() {
            $host = $_SERVER['HTTP_HOST'];
            if (strpos($host, 'localhost') === false) {
                return true;
            } else {
                return false;
            }
        }

        public static function get_current_path() {
            return self::isProd() ? $_SERVER['DOCUMENT_ROOT'] : 'C:\\xampp\htdocs\prdemo.com';
        }

        public static function get_pr_ext_api_host() {
            return self::isProd() ? 'https://extapi.protectremote.com' : 'http://localhost:5030';
        }
    
        public static function get_pr_rules_url() {
            return self::get_pr_ext_api_host().'/rules';
        }

        public static function get_pr_exeption_log_event_url() {
            return self::get_pr_ext_api_host().'/exceptions/log-events';
        }

        public static function get_pr_cloudflare_ipv4_url() {
            return self::get_pr_ext_api_host().'/allow-ips/cloudflare-ipv4';
        }

        public static function get_pr_cloudflare_ipv6_url() {
            return self::get_pr_ext_api_host().'/allow-ips/cloudflare-ipv6';
        }

        public static function get_pr_data_json_path() {
            return self::get_current_path() . "/wp-content/plugins/protect-remote/protect-remote-data.json";
        }

        public static function get_htaccess_file_path() {
            return self::get_current_path() . "/.htaccess";
        }

        public static function get_access_denied_file_path() {
            return self::get_current_path() . "/wp-content/plugins/protect-remote/pr-access-denied.php";
        }
        
        public static function get_pr_wp_cron_trigger_page_url() {
            return '/protect-remote-cron-trigger';
        }
        
    }
?>