<?php
    class ProtectRemoteSettingPage {

        public function __construct() {
        }

        public static function getSettingPageHtml() {
            $settingOptions = new ProtectRemoteSettingOptions();

            $protocol = isset($_SERVER['HTTPS']) && $_SERVER['HTTPS'] === 'on' ? 'https://' : 'http://';
            $http_host = $_SERVER['HTTP_HOST'];
            $domain = $protocol.$http_host;

            return '<div class="wrap">
                        <h1 class="pr-title"><img class="pr-logo" src="https://protectremote.com/assets/imgs/logos/wordpress-protectremote-logo.png" ></h1>
                        <form method="post" action="">
                            <div class="form-group">
                                <label for="pr_token">Token</label><br/>
                                <textarea rows="5" class="pr-input w-full pr-token-textarea" type="text" name="pr_token" id="pr_token">'.esc_attr($settingOptions->getToken()).'</textarea>
                            </div>
                            <div class="form-group">
                                <table class="pr-table">
                                    <thead class="pr-table-head">
                                        <tr>
                                            <th class="pr-table-head-col">Flag</th>
                                            <th class="pr-table-head-col"></th>
                                            <th class="pr-table-head-col">Description</th>
                                        </tr>
                                    </thead>
                                    <tbody class="pr-table-body">
                                        <tr class="pr-table-row">
                                            <td class="pr-table-flag-column"><label for="pr_flag_login_page">Login Page</label></td>
                                            <td class="pr-table-value-column"><input type="checkbox" '.($settingOptions->getFlagLoginPage() == true ? 'checked="true"' : "").' id="pr_flag_login_page" name="pr_flag_login_page" value="1"></td>
                                            <td class="pr-table-description-column">It prevents unauthorized access to the login page.</td>
                                        </tr>
                                        <tr class="pr-table-row">
                                            <td class="pr-table-flag-column"><label for="pr_flag_admin_panel">Admin Panel</label></td>
                                            <td class="pr-table-value-column"><input type="checkbox" '.($settingOptions->getFlagAdminPanel() == true ? 'checked="true"' : "").' id="pr_flag_admin_panel" name="pr_flag_admin_panel" value="1"></td>
                                            <td class="pr-table-description-column">It prevents unauthorized access to the administration panel and the entire "wp-admin" directory.</td>
                                        </tr>
                                        <tr class="pr-table-row">
                                            <td class="pr-table-flag-column"><label for="pr_flag_admin_ajax">Allow admin-ajax.php </label></td>
                                            <td class="pr-table-value-column"><input type="checkbox" '.($settingOptions->getFlagAdminAjax() == true ? 'checked="true"' : "").' id="pr_flag_admin_ajax" name="pr_flag_admin_ajax" value="1"> </td>
                                            <td class="pr-table-description-column">Some plugins need communication with the "/wp-admin/admin-ajax.php" file to work. You can activate it if necessary. (Allowing this access may cause security vulnerabilities.)</td>
                                        </tr>
                                        <tr class="pr-table-row">
                                            <td class="pr-table-flag-column"><label for="pr_flag_website">All Web Site </label></td>
                                            <td class="pr-table-value-column"><input type="checkbox" '.($settingOptions->getFlagWebsite() == true ? 'checked="true"' : "").' id="pr_flag_website" name="pr_flag_website" value="1"></td>
                                            <td class="pr-table-description-column">It blocks the entire site from unauthorized access. Only Protect Remote users can access the site.</td>
                                        </tr>
                                        <tr class="pr-table-row">
                                            <td class="pr-table-flag-column"><label for="pr_flag_hide_users">Hide Users </label></td>
                                            <td class="pr-table-value-column"><input type="checkbox" '.($settingOptions->getFlagHideUsers() == true ? 'checked="true"' : "").' id="pr_flag_hide_users" name="pr_flag_hide_users" value="1"></td>
                                            <td class="pr-table-description-column">The admin\'s username may be stolen in requests made to "<a target="_blank" href="'.$domain.'/wp-json/wp/v2/users">'.$domain.'/wp-json/wp/v2/users</a>" and ""<a target="_blank" href="'.$domain.'/?author=1">'.$domain.'/?author=1</a>". Blocking these addresses prevents this security vulnerability.</td>
                                        </tr>
                                        <tr class="pr-table-row">
                                            <td class="pr-table-flag-column">Login Page URL</td>
                                            <td class="pr-table-value-column"><input class="pr-input w-full" type="text" id="pr_wp_login_page_url" name="pr_wp_login_page_url" value="'.esc_attr($settingOptions->getWpLoginPageUrl()).'"></td>
                                            <td class="pr-table-description-column">You have an option to customize the login page URL if desired. (Protect Remote already effectively prevents unauthorized login attempts.)</td>
                                        </tr>
                                    </tbody>
                                </table>
                                <hr />
                                <table class="pr-table">
                                    <thead class="pr-table-head">
                                        <tr>
                                            <th class="pr-table-head-col">Feature</th>
                                            <th class="pr-table-head-col"></th>
                                            <th class="pr-table-head-col">Description</th>
                                        </tr>
                                    </thead>
                                    <tbody class="pr-table-body">
                                        <tr class="pr-table-row">
                                            <td class="pr-table-flag-column"><label for="pr_footer_link">Footer Link</label></td>
                                            <td class="pr-table-value-column"><input type="checkbox" '.($settingOptions->getFooterLink() == true ? 'checked="true"' : "").' id="pr_footer_link" name="pr_footer_link" value="1"></td>
                                            <td class="pr-table-description-column"> Adds “Protected by Remote Remote” to the footer.</td>
                                        </tr>
                                    </tbody>
                                </table>
                            </div>
                            
                            <div class="form-group">
                                <input type="submit" value="Save All Settings" class="button-secondary" />
                            </div>
                            
                        </form>
                    </div>
                    <style>
                        .button-secondary {background-color: #000000 !important; color: white !important; cursor: pointer;}
                        .pr-logo {width: 30%; min-width: 250px; max-width: 500px;}
                        .pr-table-row {border-bottom: 1px solid gray;}
                        .pr-token-textarea {}
                        .pr-table {width: 100%; border-collapse: collapse;}
                        .pr-table-head-col {border-bottom: 1px solid gray; padding: 10px 15px;text-align: left;}
                        .pr-table-head {background-color: #c94e3d; color: white; font-weight: bold;}
                        .pr-table-flag-column {padding: 10px 15px; font-weight: bold;}
                        .pr-table-value-column {padding: 10px 15px;}
                        .pr-table-description-column {padding: 10px 15px;}
                        .pr-pages {width: 40%; line-height: 50px;}
                        .pr-row {width: 100%; display: flex;}
                        .pr-page  { width: 30% }
                        .pr-page-value { width: 70%;  }
                        .w-full {width: 100%}
                        .pr-page label { padding-top: 10px }
                        .form-group label {font-weight: bold;}
                        .form-group { width: 100%; margin-bottom: 15px;}
                        .pr-label {font-size: 20px;}
                        .pr-label-option {font-size:16px; color:#646464; margin-right:10px}
                        .pr-input {margin-top:10px}
                        .pr-title {margin-top:15px !important;; margin-bottom: 25px !important; font-weight: bold !important; color: #d63638!important;}
                        .pr-trigger-danger { font-size: 16px }
                        .form-group strong {font-size: 16px; color: #d63638!important; font-weight: bold; margin-bottom: 10px; display: block;}
                        .note-block {border: 1px solid #d63638; padding: 10px; border-radius: 5px; margin-top: 20px; width: 98%;}
                    </style>';
        }

        static function protect_remote_settings_page() {

            $settingOptions = new ProtectRemoteSettingOptions();
        
            if ($_SERVER['REQUEST_METHOD'] === 'POST') {

                if (isset($_POST['pr_footer_link'])) {
                    $settingOptions->setFooterLink(sanitize_text_field($_POST['pr_footer_link']));
                }  else {
                    $settingOptions->setFooterLink("0");
                }

                if (isset($_POST['pr_token'])) {
                    $settingOptions->setToken(sanitize_text_field($_POST['pr_token']));
                }

                if (isset($_POST['pr_wp_login_page_url'])) {
                    $settingOptions->setWpLoginPageUrl(sanitize_text_field($_POST['pr_wp_login_page_url']));
                }
    
                if (isset($_POST['pr_flag_login_page'])) {
                    $settingOptions->setFlagLoginPage(sanitize_text_field($_POST['pr_flag_login_page']));
                } else {
                    $settingOptions->setFlagLoginPage(0);
                }
    
                if (isset($_POST['pr_flag_admin_panel'])) {
                    $settingOptions->setFlagAdminPanel(sanitize_text_field($_POST['pr_flag_admin_panel']));
                } else {
                    $settingOptions->setFlagAdminPanel(0);
                }

                if (isset($_POST['pr_flag_admin_ajax'])) {
                    $settingOptions->setFlagAdminAjax(sanitize_text_field($_POST['pr_flag_admin_ajax']));
                } else {
                    $settingOptions->setFlagAdminAjax(0);
                }
    
                if (isset($_POST['pr_flag_website'])) {
                    $settingOptions->setFlagWebsite(sanitize_text_field($_POST['pr_flag_website']));
                } else {
                    $settingOptions->setFlagWebsite(0);
                }

                if (isset($_POST['pr_flag_hide_users'])) {
                    $settingOptions->setFlagHideUsers(sanitize_text_field($_POST['pr_flag_hide_users']));
                } else {
                    $settingOptions->setFlagHideUsers(0);
                }
    
                if (isset($_POST['pr_token'])) {
                    echo '<div class="notice notice-success"><p>Settings updated</p></div>';
                }    

                $settingOptions->saveChanges();
            }

            ?>
            <?php echo ProtectRemoteSettingPage::getSettingPageHtml(); ?>
            <?php
        }
    }
?>