<?php require "View/ProtectRemoteSettingPage.php"; ?>
<?php require "Models/ProtectRemoteVariables.php"; ?>
<?php require "Models/ProtectRemoteData.php" ?>
<?php require "Models/ProtectRemoteKeyword.php" ?>
<?php require "Models/ProtectRemoteSettingOption.php" ?>
<?php require "Application/ProtectRemoteInit.php"; ?>
<?php require "Application/ProtectRemoteCron.php"; ?>
<?php require "Application/ProtectRemoteLog.php"; ?>
<?php require "Application/ProtectRemote.php"; ?>
<?php
    /*
    Plugin Name: Protect Remote
    Plugin URI: https://protectremote.com/product/integrations/wordpress
    Description: Next-gen security solution
    Version: 0.0.9
    Author: Protect Remote
    Author URI: https://protectremote.com
    */

    ob_start();
    @session_start();
    if (!defined('ABSPATH')) {
        exit;
    }

    register_activation_hook(__FILE__, 'ProtectRemoteInit::init');

    register_deactivation_hook(__FILE__, 'ProtectRemoteInit::destroy');

    add_action('admin_menu', 'ProtectRemoteInit::add_protect_remote_settings_page');

    add_filter('plugin_row_meta', 'pr_plugin_settings_link', 10, 2);

    ProtectRemoteCron::pr_cron();

    function pr_plugin_settings_link($links, $file) {
        if (plugin_basename(__FILE__) == $file) {
            $settings_link = '<a href="' . admin_url('options-general.php?page='.ProtectRemoteVariables::PLUGIN_KEY) . '">Settings Page</a>';
            $links[] = $settings_link;
        }
        return $links;
    }

    $settingOptions = new ProtectRemoteSettingOptions();

    if ($settingOptions->getFooterLink()) {

        $footerKeywordId = $settingOptions->getWpFooterKeywordId();

        if ($footerKeywordId == -1) {
            $footerKeywordId = KeywordLinkList::getRandomIndex();
            $settingOptions->setWpFooterKeywordId($footerKeywordId);
            $settingOptions->saveChanges();
        }

        $seoObj = KeywordLinkList::getObjectAtIndex($footerKeywordId);
    
        add_action('wp_footer', 'ProtectRemoteInit::pr_footer_link');
    }    
?>